from typing import Any, Dict, List, Type, TypeVar

from attrs import define as _attrs_define
from attrs import field as _attrs_field

T = TypeVar("T", bound="GetDepotsResponseItem")


@_attrs_define
class GetDepotsResponseItem:
    """
    Attributes:
        id (str):  Example: id.
        label (str):  Example: string.
        longitude (float):
        latitude (float):
    """

    id: str
    label: str
    longitude: float
    latitude: float
    additional_properties: Dict[str, Any] = _attrs_field(init=False, factory=dict)

    def to_dict(self) -> Dict[str, Any]:
        id = self.id

        label = self.label

        longitude = self.longitude

        latitude = self.latitude

        field_dict: Dict[str, Any] = {}
        field_dict.update(self.additional_properties)
        field_dict.update(
            {
                "id": id,
                "label": label,
                "longitude": longitude,
                "latitude": latitude,
            }
        )

        return field_dict

    @classmethod
    def from_dict(cls: Type[T], src_dict: Dict[str, Any]) -> T:
        d = src_dict.copy()
        id = d.pop("id")

        label = d.pop("label")

        longitude = d.pop("longitude")

        latitude = d.pop("latitude")

        get_depots_response_item = cls(
            id=id,
            label=label,
            longitude=longitude,
            latitude=latitude,
        )

        get_depots_response_item.additional_properties = d
        return get_depots_response_item

    @property
    def additional_keys(self) -> List[str]:
        return list(self.additional_properties.keys())

    def __getitem__(self, key: str) -> Any:
        return self.additional_properties[key]

    def __setitem__(self, key: str, value: Any) -> None:
        self.additional_properties[key] = value

    def __delitem__(self, key: str) -> None:
        del self.additional_properties[key]

    def __contains__(self, key: str) -> bool:
        return key in self.additional_properties
